module 
#include "stream.t"
#include "sim.t"
export countup;
/* countup d ck cl Load data, count up output at rising edge of CK,
 * Set output to zero while CL is true,
 * Set output to DATA while LOAD is true and CL is FLASE
 */
rec	countup d ck cl load data = countup' 0 (Delayb d ck) (Delayb d cl)
					     (Delayb d load) (Delayi d data)

and	countup' last (c::ckr) (true::clr) (l::lr) (d::dr) =
		0::countup' 0 ckr clr lr dr
||	countup' last ($::ckr) ($::clr) (true::lr) (d::dr) =
		d::countup' d ckr clr lr dr
||	countup' last (false::true::ckr) ($::$::clr) ($::$::lr) ($::$::dr) =
		last::(last+1)::countup' (last+1) ckr clr lr dr
||	countup' last ($::ckr) ($::clr) ($::lr) ($::dr) =
		last::countup' last ckr clr lr dr
end
